Index: squid/src/auth/ntlm/auth_ntlm.c
diff -u squid/src/auth/ntlm/auth_ntlm.c:1.18.2.1.4.25 squid/src/auth/ntlm/auth_ntlm.c:1.18.2.1.4.24.2.7
--- squid/src/auth/ntlm/auth_ntlm.c:1.18.2.1.4.25	Sun Feb 26 01:14:43 2006
+++ squid/src/auth/ntlm/auth_ntlm.c	Sun Feb 26 01:52:32 2006
@@ -872,7 +579,7 @@
     dlink_node *node;
     assert(auth_user_request->auth_user == NULL);
     auth_user_request->auth_user = authenticateAuthUserNew("ntlm");
-    auth_user_request->auth_user->auth_type = AUTH_NTLM;
+    auth_user_request->auth_user->auth_type = AUTH_NEGOTIATE;
     auth_user_request->auth_user->scheme_data = memPoolAlloc(ntlm_user_pool);
     auth_user_request->scheme_data = memPoolAlloc(ntlm_request_pool);
     memset(auth_user_request->scheme_data, '\0', sizeof(ntlm_request_t));
@@ -881,7 +588,8 @@
     node = dlinkNodeNew();
     dlinkAdd(auth_user_request, node, &auth_user_request->auth_user->requests);
 
-    /* all we have to do is identify that it's NTLM - the helper does the rest */
+    /* the helper does the rest, with data collected in
+     * authenticateNTLMAuthenticateUser */
     debug(29, 9) ("authenticateDecodeNTLMAuth: NTLM authentication\n");
     return;
 }
@@ -893,47 +601,11 @@
 }
 
 
-/* there is a known race where a single client recieves the same challenge
- * and sends the same response to squid on a single select cycle.
- * Check for this and if found ignore the new link 
- */
-static void
-authenticateNTLMChallengeCacheAddLink(const char *key, auth_user_t * auth_user, helper_stateful_server * auth_server)
-{
-    ntlm_challenge_hash_pointer *challenge_hash;
-    ntlm_user_t *ntlm_user;
-    ntlm_helper_state_t *helperstate = helperStatefulServerGetData(auth_server);
-    ntlm_user = auth_user->scheme_data;
-    /* prevent duplicates */
-    if (hash_lookup(ntlm_challenge_cache, key))
-	return;
-    challenge_hash = memPoolAlloc(ntlm_challenge_pool);
-    challenge_hash->key = xstrdup(key);
-    challenge_hash->user.auth_user = auth_user;
-    dlinkAddTail(challenge_hash, &challenge_hash->user.link, &ntlm_user->challenge_list);
-    challenge_hash->challenge.authserver = auth_server;
-    dlinkAddTail(challenge_hash, &challenge_hash->challenge.link, &helperstate->user_list);
-    hash_join(ntlm_challenge_cache, (hash_link *) challenge_hash);
-}
-
-static void
-authenticateNTLMChallengeCacheRemoveLink(ntlm_challenge_hash_pointer * challenge_hash)
-{
-    ntlm_user_t *ntlm_user = challenge_hash->user.auth_user->scheme_data;
-    ntlm_helper_state_t *helperstate = helperStatefulServerGetData(challenge_hash->challenge.authserver);
-    hash_remove_link(ntlm_challenge_cache, (hash_link *) challenge_hash);
-    dlinkDelete(&challenge_hash->user.link, &ntlm_user->challenge_list);
-    dlinkDelete(&challenge_hash->challenge.link, &helperstate->user_list);
-    xfree(challenge_hash->key);
-    memPoolFree(ntlm_challenge_pool, challenge_hash);
-}
-
-
 static int
 authNTLMAuthenticated(auth_user_request_t * auth_user_request)
 {
     ntlm_request_t *ntlm_request = auth_user_request->scheme_data;
-    if (ntlm_request->auth_state == AUTHENTICATE_STATE_DONE)
+    if (ntlm_request->auth_state == AUTHENTICATE_STATE_FINISHED)
 	return 1;
     debug(29, 9) ("User not fully authenticated.\n");
     return 0;
@@ -942,19 +614,15 @@
 static void
 authenticateNTLMAuthenticateUser(auth_user_request_t * auth_user_request, request_t * request, ConnStateData * conn, http_hdr_type type)
 {
-    const char *proxy_auth;
+    const char *proxy_auth, *blob;
     auth_user_hash_pointer *usernamehash;
-    ntlm_challenge_hash_pointer *challenge_hash = NULL;
     auth_user_t *auth_user;
     ntlm_request_t *ntlm_request;
     ntlm_user_t *ntlm_user;
-    LOCAL_ARRAY(char, ntlmhash, NTLM_CHALLENGE_SZ * 2);
-    /* get header */
-    proxy_auth = httpHeaderGetStr(&request->header, type);
 
     auth_user = auth_user_request->auth_user;
     assert(auth_user);
-    assert(auth_user->auth_type == AUTH_NTLM);
+    assert(auth_user->auth_type == AUTH_NEGOTIATE);
     assert(auth_user->scheme_data != NULL);
     assert(auth_user_request->scheme_data != NULL);
     ntlm_user = auth_user->scheme_data;
@@ -966,13 +634,33 @@
 	debug(29, 1) ("authenticateNTLMAuthenticateUser: attempt to perform authentication without a connection!\n");
 	return;
     }
+    if (ntlm_request->waiting) {
+	debug(29, 1) ("authenticateNTLMAuthenticateUser: waiting for helper reply!\n");
+	return;
+    }
+    if (ntlm_request->server_blob) {
+	debug(29, 2) ("authenticateNTLMAuthenticateUser: need to challenge client '%s'!\n", ntlm_request->server_blob);
+	return;
+    }
+
+    /* get header */
+    proxy_auth = httpHeaderGetStr(&request->header, type);
+    blob = proxy_auth;
+    while (xisspace(*blob) && *blob)
+	blob++;
+    while (!xisspace(*blob) && *blob)
+	blob++;
+    while (xisspace(*blob) && *blob)
+	blob++;
+
     switch (ntlm_request->auth_state) {
     case AUTHENTICATE_STATE_NONE:
-	/* we've recieved a negotiate request. pass to a helper */
+	/* we've recieved a ntlm request. pass to a helper */
 	debug(29, 9) ("authenticateNTLMAuthenticateUser: auth state ntlm none. %s\n", proxy_auth);
-	ntlm_request->auth_state = AUTHENTICATE_STATE_NEGOTIATE;
-	ntlm_request->ntlmnegotiate = xstrdup(proxy_auth);
-	conn->auth_type = AUTH_NTLM;
+	ntlm_request->auth_state = AUTHENTICATE_STATE_INITIAL;
+	safe_free(ntlm_request->client_blob);
+	ntlm_request->client_blob = xstrdup(blob);
+	conn->auth_type = AUTH_NEGOTIATE;
 	conn->auth_user_request = auth_user_request;
 	ntlm_request->conn = conn;
 	/* and lock for the connection duration */
@@ -980,68 +668,24 @@
 	authenticateAuthUserRequestLock(auth_user_request);
 	return;
 	break;
-    case AUTHENTICATE_STATE_NEGOTIATE:
-	ntlm_request->auth_state = AUTHENTICATE_STATE_CHALLENGE;
-	/* We _MUST_ have the auth challenge by now */
-	assert(ntlm_request->authchallenge);
+    case AUTHENTICATE_STATE_INITIAL:
+	debug(29, 1) ("authenticateNTLMAuthenticateUser: need to ask helper!\n");
 	return;
 	break;
-    case AUTHENTICATE_STATE_CHALLENGE:
-	/* we should have recieved a NTLM challenge. pass it to the same 
+    case AUTHENTICATE_STATE_NEGOTIATE:
+	/* we should have recieved a blob from the clien. pass it to the same 
 	 * helper process */
 	debug(29, 9) ("authenticateNTLMAuthenticateUser: auth state challenge with header %s.\n", proxy_auth);
 	/* do a cache lookup here. If it matches it's a successful ntlm 
 	 * challenge - release the helper and use the existing auth_user 
 	 * details. */
-	ntlm_request->ntlmauthenticate = xstrdup(proxy_auth);
-	/* normal case with challenge reuses disabled */
-	if (ntlmConfig->challengeuses == 0) {
-	    /* verify with the ntlm helper */
-	    ntlm_request->auth_state = AUTHENTICATE_STATE_RESPONSE;
-	    return;
-	}
-	/* cache entries have authenticateauthheaderchallengestring */
-	snprintf(ntlmhash, sizeof(ntlmhash) - 1, "%s%s",
-	    ntlm_request->ntlmauthenticate,
-	    ntlm_request->authchallenge);
-	/* see if we already know this user's authenticate */
-	debug(29, 9) ("aclMatchProxyAuth: cache lookup with key '%s'\n", ntlmhash);
-	assert(ntlm_challenge_cache != NULL);
-	challenge_hash = hash_lookup(ntlm_challenge_cache, ntlmhash);
-	if (!challenge_hash) {	/* not in the hash table */
-	    debug(29, 4) ("authenticateNTLMAuthenticateUser: proxy-auth cache miss.\n");
-	    ntlm_request->auth_state = AUTHENTICATE_STATE_RESPONSE;
-	    /* verify with the ntlm helper */
-	} else {
-	    debug(29, 4) ("authenticateNTLMAuthenticateUser: ntlm proxy-auth cache hit\n");
-	    /* throw away the temporary entry */
-	    ntlm_request->authserver_deferred = 0;
-	    authenticateNTLMReleaseServer(ntlm_request);
-	    authenticateAuthUserMerge(auth_user, challenge_hash->user.auth_user);
-	    auth_user = challenge_hash->user.auth_user;
-	    auth_user_request->auth_user = auth_user;
-	    ntlm_request->auth_state = AUTHENTICATE_STATE_DONE;
-	    /* we found one */
-	    debug(29, 9) ("found matching cache entry\n");
-	    assert(auth_user->auth_type == AUTH_NTLM);
-	    /* get the existing entries details */
-	    ntlm_user = auth_user->scheme_data;
-	    debug(29, 9) ("Username to be used is %s\n", ntlm_user->username);
-	    /* on ntlm auth we do not unlock the auth_user until the
-	     * connection is dropped. Thank MS for this quirk */
-	    auth_user->expiretime = current_time.tv_sec;
-	}
+	safe_free(ntlm_request->client_blob);
+	ntlm_request->client_blob = xstrdup(blob);
 	return;
 	break;
-    case AUTHENTICATE_STATE_RESPONSE:
-	/* auth-challenge pair cache miss. We've just got the response from the helper */
-	/*add to cache and let them through */
-	ntlm_request->auth_state = AUTHENTICATE_STATE_DONE;
+    case AUTHENTICATE_STATE_FINISHED:
 	/* this connection is authenticated */
-	debug(29, 4) ("authenticated\nch    %s\nauth     %s\nauthuser %s\n",
-	    ntlm_request->authchallenge,
-	    ntlm_request->ntlmauthenticate,
-	    ntlm_user->username);
+	debug(29, 4) ("authenticated user %s\n", ntlm_user->username);
 	/* see if this is an existing user with a different proxy_auth 
 	 * string */
 	usernamehash = hash_lookup(proxy_auth_username_cache, ntlm_user->username);
@@ -1060,17 +704,11 @@
 	    /* store user in hash's */
 	    authenticateUserNameCacheAdd(auth_user);
 	}
-	if (ntlmConfig->challengeuses) {
-	    /* cache entries have authenticateauthheaderchallengestring */
-	    snprintf(ntlmhash, sizeof(ntlmhash) - 1, "%s%s",
-		ntlm_request->ntlmauthenticate,
-		ntlm_request->authchallenge);
-	    authenticateNTLMChallengeCacheAddLink(ntlmhash, auth_user, ntlm_request->authserver);
-	}
 	/* set these to now because this is either a new login from an 
 	 * existing user or a new user */
 	auth_user->expiretime = current_time.tv_sec;
 	authenticateNTLMReleaseServer(ntlm_request);
+	ntlm_request->auth_state = AUTHENTICATE_STATE_DONE;
 	return;
     case AUTHENTICATE_STATE_DONE:
 	fatal("authenticateNTLMAuthenticateUser: unexpect auth state DONE! Report a bug to the squid developers.\n");
Index: squid/src/auth/ntlm/auth_ntlm.h
diff -u squid/src/auth/ntlm/auth_ntlm.h:1.8.10.4 squid/src/auth/ntlm/auth_ntlm.h:1.8.10.4.2.3
--- squid/src/auth/ntlm/auth_ntlm.h:1.8.10.4	Tue Feb 22 04:59:28 2005
+++ squid/src/auth/ntlm/auth_ntlm.h	Tue Nov  8 10:32:53 2005
@@ -10,9 +10,9 @@
 
 typedef enum {
     AUTHENTICATE_STATE_NONE,
+    AUTHENTICATE_STATE_INITIAL,
     AUTHENTICATE_STATE_NEGOTIATE,
-    AUTHENTICATE_STATE_CHALLENGE,
-    AUTHENTICATE_STATE_RESPONSE,
+    AUTHENTICATE_STATE_FINISHED,
     AUTHENTICATE_STATE_DONE,
     AUTHENTICATE_STATE_FAILED
 } auth_state_t;			/* connection level auth state */
@@ -27,62 +27,33 @@
 struct _ntlm_user {
     /* what username did this connection get? */
     char *username;
-    dlink_list challenge_list;
 };
 
-struct _ntlm_challenge_hash_pointer {
-    /* first two items must be same as hash_link */
-    char *key;
-    auth_user_hash_pointer *next;
-    struct {
-	auth_user_t *auth_user;
-	dlink_node link;	/* other hash entries that point to the same auth_user */
-    } user;
-    struct {
-	helper_stateful_server *authserver;
-	dlink_node link;	/* other hash entries that point to the same challenge */
-    } challenge;
-};
-
-
 struct _ntlm_request {
-    /* what negotiate string did the client use? */
-    char *ntlmnegotiate;
-    /* what challenge did we give the client? */
-    char *authchallenge;
-    /* what authenticate string did we get? */
-    char *ntlmauthenticate;
-    /*we need to store the NTLM server between requests */
+    /*we need to store the helper server between requests */
     helper_stateful_server *authserver;
     /* how far through the authentication process are we? */
     auth_state_t auth_state;
-    /* have we got the helper-server in a deferred state? */
-    int authserver_deferred;
+    /* currently waiting for helper response */
+    int waiting;
     /* what connection is this associated with */
     ConnStateData *conn;
-};
-
-struct _ntlm_helper_state_t {
-    char *challenge;		/* the challenge to use with this helper */
-    int starve;			/* 0= normal operation. 1=don't hand out any more challenges */
-    int challengeuses;		/* the number of times this challenge has been issued */
-    time_t renewed;
-    dlink_list user_list;	/* ntlm_challenge_hash_pointer list referring to this challenge */
+    /* our current blob to pass to the client */
+    char *server_blob;
+    /* our current blob to pass to the server */
+    char *client_blob;
 };
 
 /* configuration runtime data */
 struct _auth_ntlm_config {
     int authenticateChildren;
-    wordlist *authenticate;
-    int challengeuses;
-    time_t challengelifetime;
+    int keep_alive;
     int use_ntlm_negotiate;
+    wordlist *authenticate;
 };
 
 typedef struct _ntlm_user ntlm_user_t;
 typedef struct _ntlm_request ntlm_request_t;
-typedef struct _ntlm_helper_state_t ntlm_helper_state_t;
 typedef struct _auth_ntlm_config auth_ntlm_config;
-typedef struct _ntlm_challenge_hash_pointer ntlm_challenge_hash_pointer;
 
 #endif
